/* xmp3tag.c  - X11 interface (Motif) for MP3 TAG Editor orginally written
				by Marcin Baranowski (minek@kis.p.lodz.pl).
				   
 *	Copyright (C) 1998  Marek Blaszkowski (mb@kis.p.lodz.pl).
 *      [ send comments and bug reports to mb@kis.p.lodz.pl]
 *
 *    This is very ALPHA code (may be unstable in some cases)
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 */
 
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/BulletinB.h>
#include <Xm/Label.h>
#include <Xm/Text.h>
#include <Xm/FileSB.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/Separator.h>
#include <Xm/Form.h>
#include <Xm/DialogS.h>
#include <Xm/PushB.h>
#include <Xm/DrawingA.h>
#include <Xm/List.h>
#include <Xm/ScrolledW.h>
#include <Xm/MessageB.h>
#include <Xm/TextF.h>
#include <Xm/DrawnB.h>
#include <Xm/Frame.h>
#include <Xm/MainW.h>
#include <Xm/PanedW.h>
#include <Xm/SelectioB.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "mp3tag.h"

#define NUMITEMS 116
XmString xarray[NUMITEMS];

XtAppContext app;

Arg args[15];

char nazwa_pliku[512];

Widget top,masterForm;
Widget inputTytul,labelTytul;
Widget labelWykonawca,inputWykonawca,labelAlbum,inputAlbum;
Widget labelRok,inputRok,labelGatunek,inputGatunek;
Widget labelKomentarz,inputKomentarz;
Widget button1,button2,button3,labelplik,filebox,form2,formgat;
Widget button4,button5,button6,button7;
Widget inp1,inp2,shell_gr,labelron;
int x,i,y;
char c;
XmString roz,t1,geom,t2;
char *txt,tmp[30];
int tt;
pid_t pid,p;
char arg[512],name[512];
Boolean Play,z,run=True;


void zmiana__(Boolean zm){
XtVaGetValues(button2,XmNpushButtonEnabled,&z,NULL);
               
if(zm&&(!z)){
		XtAddCallback(button2,XmNactivateCallback,save,NULL);
		XtVaSetValues(button2,
                XmNpushButtonEnabled,
				True,
                NULL);
            
        }
 if(z&&(!zm)){
     
      		XtRemoveCallback(button2,XmNactivateCallback,save,NULL);
      		XtVaSetValues(button2,
                XmNpushButtonEnabled,
				False,
                NULL); 
            
           }
          
}                
void zmiana_(){
zmiana__(True);
                
}

void bye(Widget w,XtPointer clientdata,XtPointer calldata)
{
if(Play)stop_play(NULL,NULL,NULL);
exit(0);
}

void about(Widget w,XtPointer clientdata,XtPointer calldata)
{
Widget rc,shell,butt1,lab,lab1,lab2;
char lt[40];
char *lt1="Marek Blaszkowski    (mb@kis.p.lodz.pl)";
char *lt2="(c) 1998";
/*char *lt2="Marcin Baranowski  (minek@kis.p.lodz.pl)"; 
*/
strcpy(lt,"X11 interface for MP3 Tag Editor v");
strcat(lt,VERSION);
shell=XtVaCreateWidget("form2",xmDialogShellWidgetClass,
		top,
		XmNwidth,100,
		XmNheight,100, 
		
		NULL);

rc = XtVaCreateWidget ("OK", xmFormWidgetClass, shell,
                        XmNentryAlignment,      XmALIGNMENT_CENTER, 
                      /*  XmNorientation,         XmHORIZONTAL, 
                        XmNpacking,             XmPACK_COLUMN, 
                       */ 
                    
                        XmNwidth,               300,
                        XmNheight,              100,
                NULL);
butt1 = XtVaCreateManagedWidget ("OK", xmPushButtonWidgetClass, rc,
                        XmNleftAttachment,      XmATTACH_FORM,
                        XmNleftOffset,          100,
                        XmNrightAttachment,     XmATTACH_FORM,
                        XmNrightOffset,         100,
                        XmNbottomAttachment,    XmATTACH_FORM,
                NULL);
lab=XtVaCreateManagedWidget(lt,xmLabelWidgetClass,rc,
			XmNalignment,XmALIGNMENT_CENTER,
			XmNleftAttachment,      XmATTACH_FORM,
            XmNrightAttachment,     XmATTACH_FORM,
            XmNtopAttachment,    XmATTACH_FORM,
		  	NULL);
lab1=XtVaCreateManagedWidget(lt1,xmLabelWidgetClass,rc,
			XmNx,20,
			XmNy,30,
		  	NULL);		  	
lab2=XtVaCreateManagedWidget(lt2,xmLabelWidgetClass,rc,
			XmNalignment,XmALIGNMENT_CENTER,
			XmNleftAttachment,      XmATTACH_FORM,
            XmNrightAttachment,     XmATTACH_FORM,
            XmNy,50,
			
		  	NULL);		  	
XtManageChild(rc);		

}

void setgat(Widget w,XtPointer client,XtPointer call)
{

XmSelectionBoxCallbackStruct        *cbp = (XmSelectionBoxCallbackStruct *)call;
/*
        char                                *s;
    XmStringTable                       li = NULL;
    XmString                            xms;
printf("11111111\n");

    if (XmStringGetLtoR(cbp->value, XmFONTLIST_DEFAULT_TAG, &s)) {
        fprintf(stderr, "Selection : %s\n", s);
        
        XtFree(s);
        }*/
       
XtVaSetValues(inputGatunek,	
 			XmNlabelString,cbp->value,
 			NULL);
 			 
 zmiana__(True);			
}

void btn_plik(Widget w,XtPointer clientdata,XtPointer calldata)
{
zmiana__(False);
fclose(mp3file);
XtVaGetValues(inputRok,XmNvalue,&txt,NULL);
		
form2=XtVaCreateWidget("form2",xmDialogShellWidgetClass,
				top,
				NULL);
filebox=XtVaCreateManagedWidget("FileBox",
                xmFileSelectionBoxWidgetClass,form2,
               XmNpattern,roz,
               XmNdialogType, XmDIALOG_FILE_SELECTION,
               XmNdirectoryValid,False,
                NULL );
                 
XtManageChild(filebox);                    
XtRemoveCallback(button1,XmNactivateCallback,btn_plik,NULL);
XtAddCallback(filebox, XmNokCallback, fileok, NULL);
XtAddCallback(filebox, XmNcancelCallback, filecancel, NULL);

/*
XtAddCallback(inputTytul,XmNvalueChangedCallback,zmiana_,NULL);	
XtAddCallback(inputWykonawca,XmNvalueChangedCallback,zmiana_,NULL);
XtAddCallback(inputAlbum,XmNvalueChangedCallback,zmiana_,NULL);
XtAddCallback(inputRok,XmNvalueChangedCallback,zmiana_,NULL);
XtAddCallback(inputKomentarz,XmNvalueChangedCallback,zmiana_,NULL);
XtAddCallback(button7,XmNactivateCallback,zm_gat,formgat);	
*/

XtRemoveCallback(inputTytul,XmNvalueChangedCallback,zmiana_,NULL);	
XtRemoveCallback(inputWykonawca,XmNvalueChangedCallback,zmiana_,NULL);	
XtRemoveCallback(inputAlbum,XmNvalueChangedCallback,zmiana_,NULL);
XtRemoveCallback(inputRok,XmNvalueChangedCallback,zmiana_,NULL);
XtRemoveCallback(inputKomentarz,XmNvalueChangedCallback,zmiana_,NULL);

XtRemoveCallback(button7,XmNactivateCallback,zm_gat,NULL);
XtVaSetValues(button7,XmNpushButtonEnabled,False,NULL);
}

void filecancel(Widget w,XtPointer clientdata,XtPointer calldata)
{
XtDestroyWidget(form2);
XtAddCallback(button1,XmNactivateCallback,btn_plik,NULL);
}



void fileok(Widget w,XtPointer clientdata,XtPointer calldata)
{

XtVaGetValues((Widget)filebox, XmNdirSpec, &t1, NULL);
XmStringGetLtoR(t1, XmFONTLIST_DEFAULT_TAG, &txt);
strcpy(nazwa_pliku,txt);	  	
x=openmp3file(txt);

if(x==0||x==-2){

    if(x==0){XtAddCallback(inputTytul,XmNvalueChangedCallback,zmiana_,NULL);	
			XtAddCallback(inputWykonawca,XmNvalueChangedCallback,zmiana_,NULL);	
			XtAddCallback(inputAlbum,XmNvalueChangedCallback,zmiana_,NULL);
			XtAddCallback(inputRok,XmNvalueChangedCallback,zmiana_,NULL);
			XtAddCallback(inputKomentarz,XmNvalueChangedCallback,zmiana_,NULL);
			XtAddCallback(button7,XmNactivateCallback,zm_gat,NULL);
			XtVaSetValues(button7,XmNpushButtonEnabled,True,NULL);
			}	
	if(x==-2){
			XtVaSetValues(labelron,XmNlabelString,
			XmStringCreateSimple("r-only!"),NULL);
			
			}
			else
			 	XtVaSetValues(labelron,XmNlabelString,
			XmStringCreateSimple(" "),NULL);
	x=readtag();
	
	XtDestroyWidget(form2);
	XtVaSetValues(labelplik,XmNlabelString,t1,NULL);
	XtVaGetValues(button2,XmNpushButtonEnabled,&z,NULL);
	if(run){
	XtAddCallback(button5,XmNactivateCallback,play,NULL);
			XtVaSetValues(button5,
                XmNpushButtonEnabled,
				True,
                NULL);
                
       }
   run=False;          
  if(x==0){
  		zmiana__(False);
  		for(i=0;i<30;i++)tmp[i]=0;
  		i=29;
  		while(mp3tag.title[i]==32)i--;
  		bcopy(mp3tag.title,tmp,i+1);
		XtVaSetValues(inputTytul,
			XmNvalue,tmp,
			NULL);  
		for(i=0;i<30;i++)tmp[i]=0;
  		i=29;
  		while(mp3tag.artist[i]==32)i--;
  		bcopy(mp3tag.artist,tmp,i+1);	
 		XtVaSetValues(inputWykonawca,	
 			XmNvalue,tmp,
 			NULL);		
 		for(i=0;i<30;i++)tmp[i]=0;
  		i=29;
  		while(mp3tag.album[i]==32)i--;
  		bcopy(mp3tag.album,tmp,i+1);	 		
		XtVaSetValues(inputAlbum,	
 			XmNvalue,tmp,
 			NULL); 
 		for(i=0;i<5;i++)tmp[i]=0;
  		i=3;
  		while(mp3tag.year[i]==32)i--;
  		bcopy(mp3tag.year,tmp,i+1);	 				
	  	XtVaSetValues(inputRok,	
 			XmNvalue,tmp,
 			NULL);		
 		for(i=0;i<30;i++)tmp[i]=0;
  		i=29;
  		while(mp3tag.comment[i]==32)i--;
  		bcopy(mp3tag.comment,tmp,i+1);
 		XtVaSetValues(inputKomentarz,	
 			XmNvalue,tmp,
 			NULL);		
 		i=0;	
 		while(strcmp((char*)genre[i].genre,(char *)genwrite( mp3tag.genre )))i++;	
		/*XtVaSetValues(formgat,XmNtopItemPosition,++i,NULL);*/	
		XtVaSetValues(inputGatunek,	
 			XmNlabelString,XmStringCreateSimple((char *)genwrite( mp3tag.genre )),
 			NULL); 	
 		
 				
	  		
      }
      else {
      	XtVaSetValues(inputTytul,
			XmNvalue,"",
			NULL);  
 		XtVaSetValues(inputWykonawca,	
 			XmNvalue,"",
 			NULL);			 		
		XtVaSetValues(inputAlbum,	
 			XmNvalue,"",
 			NULL);  			
	  	XtVaSetValues(inputRok,	
 			XmNvalue,"",
 			NULL);
		XtVaSetValues(inputGatunek,	
 			XmNlabelString,XmStringCreateSimple(" "),
 			NULL); 
 		XtVaSetValues(inputKomentarz,	
 			XmNvalue,"",
 			NULL);			
		}
  
 
	XtAddCallback(button1,XmNactivateCallback,btn_plik,NULL);

	}				
}

void save(Widget w,XtPointer clientdata,XtPointer calldata)
{

for(i=0;i<30;i++){
					mp3tag.title[i]=32;
					mp3tag.artist[i]=32;
					mp3tag.album[i]=32;
					mp3tag.comment[i]=32;
					if(i<4)mp3tag.year[i]=32;
					}
					
XtVaGetValues(inputTytul,XmNvalue,&txt,NULL);

bcopy(txt,mp3tag.title,strlen(txt));


XtVaGetValues(inputWykonawca,XmNvalue,&txt,NULL);
bcopy(txt,mp3tag.artist,strlen(txt));


XtVaGetValues(inputAlbum,XmNvalue,&txt,NULL);
bcopy(txt,mp3tag.album,strlen(txt));

XtVaGetValues(inputRok,XmNvalue,&txt,NULL);
bcopy(txt,mp3tag.year,strlen(txt));
XtVaGetValues(inputKomentarz,XmNvalue,&txt,NULL);
bcopy(txt,mp3tag.comment,strlen(txt));

XtVaGetValues(inputGatunek, XmNlabelString, &t1, NULL);
XmStringGetLtoR(t1, XmFONTLIST_DEFAULT_TAG, &txt);
strncpy(tmp,txt,17);
c=0;
while(strcmp((char*)genre[c].genre,tmp))c++;
mp3tag.genre=genre[c].ch;
savetag();
fclose(mp3file);
zmiana__(False);
}

void stop_play(Widget w,XtPointer clientdata,XtPointer calldata)
{
XtRemoveCallback(button5,XmNactivateCallback,stop_play,NULL);
kill(pid,9);
wait(NULL);
Play=False;
XtAddCallback(button5,XmNactivateCallback,play,NULL);
XtVaSetValues(button5,
				 XtVaTypedArg, XmNlabelString, XmRString,
                "Play", 5,NULL);
}


void play(Widget w,XtPointer clientdata,XtPointer calldata)
{
Widget rc_gr,butt1_gr,lab1_gr,lab2_gr;
int *stat;
char *env[]={NULL};
char *ar[10];
char buf[10][512];
/*              
shell_gr=XtVaCreateWidget("shell_gr",xmDialogShellWidgetClass,
		top,
		NULL);
rc_gr = XtVaCreateWidget ("rc_gr", xmFormWidgetClass, shell_gr,
                     XmNwidth,300,
                     XmNheight,100,              
                NULL);
butt1_gr = XtVaCreateManagedWidget ("Stop", xmPushButtonWidgetClass, rc_gr,
                      XmNleftAttachment,      XmATTACH_FORM,
                        XmNleftOffset,          60,
                        XmNrightAttachment,     XmATTACH_FORM,
                        XmNrightOffset,         60,
                        XmNbottomAttachment,    XmATTACH_FORM,
                        
                NULL);
lab1_gr=XtVaCreateManagedWidget("Playing...",xmLabelWidgetClass,rc_gr,
			  XmNleftAttachment,      XmATTACH_FORM,
                        XmNleftOffset,          60,
                        XmNrightAttachment,     XmATTACH_FORM,
                        XmNrightOffset,         60,
                        XmNtopAttachment,    XmATTACH_FORM,
		  	NULL);    
lab2_gr=XtVaCreateManagedWidget(nazwa_pliku,xmLabelWidgetClass,rc_gr,
			  XmNleftAttachment,      XmATTACH_FORM,
                        XmNleftOffset,          60,
                        XmNrightAttachment,     XmATTACH_FORM,
                        XmNrightOffset,         60,
                        XmNy,40,
                        
		  	NULL);
		  	           		  	           
XtManageChild(rc_gr);
XtAddCallback(butt1_gr,XmNactivateCallback,stop_play,NULL);	      
*/
XtVaSetValues(button5,
				 XtVaTypedArg, XmNlabelString, XmRString,
                "Stop", 5,NULL);
XtRemoveCallback(button5,XmNactivateCallback,play,NULL);
XtAddCallback(button5,XmNactivateCallback,stop_play,NULL);
Play=True;
/*
i=0;
while(arg[i]!=NULL){
				while(arg[i]!=32){
								bcopy(arg[i],buf[n][i],i

*/
ar[0]=&name[0];
ar[1]=&arg[0];
ar[2]=&nazwa_pliku[0];
ar[3]=NULL;
if(pid=fork())
{			  
			  execve(name,ar,env);
			  Play=False;
			  }
pid=getppid();	
	  			  
}

void save_setup(Widget w,XtPointer clientdata,XtPointer calldata)
{
XtVaGetValues(inp1,XmNvalue,&txt,NULL);
strcpy(name,txt);
XtVaGetValues(inp2,XmNvalue,&txt,NULL);
strcpy(arg,txt);
}

void setup(Widget w,XtPointer clientdata,XtPointer calldata)
{
Widget shell_st,rc_st,butt1_st,lab_st,lab1_st,lab2_st;

shell_st=XtVaCreateWidget("form2",xmDialogShellWidgetClass,
		top,	
		NULL);

rc_st = XtVaCreateWidget ("RC", xmFormWidgetClass, shell_st,
                     XmNwidth,300,
                     XmNheight,200,              
                NULL);
butt1_st = XtVaCreateManagedWidget ("OK", xmPushButtonWidgetClass, rc_st,
                      XmNleftAttachment,      XmATTACH_FORM,
                        XmNleftOffset,          80,
                        XmNrightAttachment,     XmATTACH_FORM,
                        XmNrightOffset,         80,
                        XmNbottomAttachment,    XmATTACH_FORM,
                        
                NULL);
lab_st=XtVaCreateManagedWidget("Program for play files *.mp3:",
						xmLabelWidgetClass,rc_st,
			 			 XmNleftAttachment,      XmATTACH_FORM,
                        XmNleftOffset,          50,
                        XmNrightAttachment,     XmATTACH_FORM,
                        XmNrightOffset,         50,
                     	XmNy,10,
		  				NULL);
lab1_st=XtVaCreateManagedWidget("Name (with path) :",xmLabelWidgetClass,rc_st,
			 			 XmNleftAttachment,      XmATTACH_FORM,
                        XmNleftOffset,          15,
                       	XmNy,50,
                     
                       
		  				NULL);    
lab2_st=XtVaCreateManagedWidget("Args:",xmLabelWidgetClass,rc_st,
			  XmNleftAttachment,      XmATTACH_FORM,
                        XmNleftOffset,          15,
                       
                        XmNy,110,
                        
		  	NULL);
		  	
inp1=XtVaCreateManagedWidget("inp1",xmTextFieldWidgetClass,rc_st,
			XmNx,50,
			XmNy,70,
			XmNwidth,210,
			XmNheight,30,
			NULL);	
			 
inp2=XtVaCreateManagedWidget("inp1",xmTextFieldWidgetClass,rc_st,
			XmNx,50,
			XmNy,130,
			XmNwidth,210,
			XmNheight,30,
			NULL);	

XtVaSetValues(inp1,XmNvalue,name,NULL);
XtVaSetValues(inp2,XmNvalue,arg,NULL);

XtManageChild(rc_st);
XtAddCallback(butt1_st,XmNactivateCallback,save_setup,NULL);

}

void zm_gat(Widget w,XtPointer clientdata,XtPointer calldata)
{

formgat=XmCreateSelectionDialog(top, "formgat", NULL, 0);
for(i=0;i<NUMITEMS;i++)
			xarray[i]=XmStringCreateLtoR((char *)genre[i].genre,
			XmSTRING_DEFAULT_CHARSET);

XtVaSetValues(formgat,
                XmNlistItemCount,NUMITEMS,
                XmNlistItems,xarray, 
                NULL );
XtAddCallback(formgat,XmNokCallback, setgat, NULL);                
XtManageChild(formgat);
}



int startupx(int argc, char **argv)
{ 

 strcpy(arg,"-q");            
 strcpy(name,"/usr/local/bin/mpg123");

argv[0]="MP3 TAG Edytor";
/*for(i=0;i<argc;i++)
printf("%s\n",argv[i]);*/
roz = XmStringCreateSimple("*.mp3");

if(argv[1]!=NULL) strcpy(nazwa_pliku,argv[1]);
   
top = XtAppInitialize(&app,"KBH",NULL,0,(Cardinal *)&argc,argv,NULL,args,0);

IsX=TRUE;

masterForm = XtVaCreateManagedWidget("Form1",xmFormWidgetClass,
		top,XmNheight,300,XmNwidth,400,
	
		
		NULL);
		
button1=XtVaCreateManagedWidget("File",xmPushButtonWidgetClass,masterForm,
		
		XmNx,65,
		XmNy,263,
		NULL);

button2=XtVaCreateManagedWidget("Save",xmDrawnButtonWidgetClass,masterForm,
		
		XmNpushButtonEnabled,
		False,
		XmNx,10,
		XmNy,263,
		NULL);		
XtVaSetValues(button2,
                XtVaTypedArg, XmNlabelString, XmRString,
                "Save", 7,
                NULL);
		
button3=XtVaCreateManagedWidget("Exit",xmPushButtonWidgetClass,masterForm,
		
		XmNx,110,
		XmNy,263,
		NULL);	
button4=XtVaCreateManagedWidget("About",xmPushButtonWidgetClass,masterForm,
		
		XmNx,350,
		XmNy,263,
		NULL);		
button5=XtVaCreateManagedWidget("Play",xmDrawnButtonWidgetClass,masterForm,
		XmNpushButtonEnabled,
		False,
		XmNx,300,
		XmNy,263,
		NULL);	
XtVaSetValues(button5,
                XtVaTypedArg, XmNlabelString, XmRString,
                "Play", 5,
                NULL);		
button6=XtVaCreateManagedWidget("Setup",xmPushButtonWidgetClass,masterForm,		
		XmNx,210,
		XmNy,263,
		NULL);					
button7=XtVaCreateManagedWidget("Change type",xmDrawnButtonWidgetClass,masterForm,		
		XmNpushButtonEnabled,
		False,
		XmNx,150,
		XmNy,190,
		NULL);
XtVaSetValues(button7,
                XtVaTypedArg, XmNlabelString, XmRString,
                "Change type", 16,
                NULL);		
labelTytul=XtVaCreateManagedWidget("Title",xmLabelWidgetClass,masterForm,
			XmNx,45,
			XmNy,45,
		  	NULL);
labelWykonawca=XtVaCreateManagedWidget("Artist",xmLabelWidgetClass,masterForm,
			XmNx,42,
			XmNy,75,
		  	NULL);
labelAlbum=XtVaCreateManagedWidget("Album",xmLabelWidgetClass,masterForm,
			XmNx,45,
			XmNy,105,
		  	NULL);
labelRok=XtVaCreateManagedWidget("Year",xmLabelWidgetClass,masterForm,
			XmNx,50,
			XmNy,135,
		  	NULL);

labelGatunek=XtVaCreateManagedWidget("Type",xmLabelWidgetClass,masterForm,
			XmNx,40,
			XmNy,170,
		  	NULL);
	  	
labelKomentarz=XtVaCreateManagedWidget("Comment",xmLabelWidgetClass,masterForm,
			XmNx,35,
			XmNy,230,
		  	NULL);	
		  		  			  			  			  			  	
inputTytul=XtVaCreateManagedWidget("inputTytul",xmTextFieldWidgetClass,masterForm,
			XmNx,100,
			XmNy,40,
			XmNwidth,200,
			XmNheight,30,
			XmNmaxLength,30,
			NULL);
	  		
inputWykonawca=XtVaCreateManagedWidget("inputWykonawca",xmTextFieldWidgetClass,masterForm,
			XmNx,100,
			XmNy,70,
			XmNwidth,200,
			XmNheight,30,
			XmNmaxLength,30,
			NULL);
  		
inputAlbum=XtVaCreateManagedWidget("inputAlbum",xmTextFieldWidgetClass,masterForm,
			XmNx,100,
			XmNy,100,
			XmNwidth,200,
			XmNheight,30,
			XmNmaxLength,30,
			NULL);		
	  		
inputRok=XtVaCreateManagedWidget("inputRok",xmTextFieldWidgetClass,masterForm,
			XmNx,100,
			XmNy,130,
			XmNwidth,45,
			XmNheight,30,
			
			XmNmaxLength,4,
			NULL);	
		  		
inputGatunek=XtVaCreateManagedWidget("",xmLabelWidgetClass,masterForm,			
			XmNx,100,
			XmNy,171,
			
			NULL);	
			
inputKomentarz=XtVaCreateManagedWidget("inputKomentarz",xmTextFieldWidgetClass,masterForm,
			XmNx,100,
			XmNy,225,
			XmNwidth,200,
			XmNheight,30,
			XmNmaxLength,30,
		  	NULL);			  			
		  		  	
labelplik=XtVaCreateManagedWidget(nazwa_pliku,xmLabelWidgetClass,masterForm,
			XmNx,10,
			XmNy,20,
		  	NULL);
		  	
labelron=XtVaCreateManagedWidget(" ",xmLabelWidgetClass,masterForm,
			XmNalignment,XmALIGNMENT_CENTER,
			XmNx,180,
			XmNy,3,
		  	NULL);



formgat=XmCreateSelectionDialog(top, "formgat", NULL, 0);
for(i=0;i<NUMITEMS;i++)
			xarray[i]=XmStringCreateLtoR((char *)genre[i].genre,
			XmSTRING_DEFAULT_CHARSET);

XtVaSetValues(formgat,
                XmNlistItemCount,NUMITEMS,
                XmNlistItems,xarray, 
                NULL );
/*
XtAddCallback(formgat,XmNokCallback, setgat, NULL);
XtAddCallback(button7,XmNactivateCallback,zm_gat,formgat);
*/

XtAddCallback(button6,XmNactivateCallback,setup,NULL);
XtAddCallback(button4,XmNactivateCallback,about,NULL);
XtAddCallback(button3,XmNactivateCallback,bye,NULL);		
XtAddCallback(button1,XmNactivateCallback,btn_plik,NULL);
XtRealizeWidget(top);
XtAppMainLoop(app);
return(0);
}
